<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-radio-group v-model="rawMode"  size="small" style="margin-right: 20px; margin-bottom: 2px">
				<el-radio-button  :label="false"  title="Modo Formulario"><i class="el-icon-edit-outline"></i></el-radio-button>
				<el-radio-button :label="true" title="Modo RAW"><i class="el-icon-tickets" /></el-radio-button>
			</el-radio-group>
			<el-button type="primary" size="small" @click="onSubmit">Aplicar</el-button>
		</template>
		<mind-form :footer="false" v-loading="loading">
			<el-row wrap>
				<el-col :xs="24" :lg="12" :xl="8">
					<el-form-item  label="Nombre">
						<el-input v-model="recurso.category"></el-input>
					</el-form-item>
				</el-col>
			</el-row>
			<el-row style="height:calc(100% - 60px)" wrap >
				<dialplan-exten  :readonly="false" :raw="rawMode" v-model="extensionData" :show-exten="true" :show-prio="true" :availableCommands="dialplanApps" />
			</el-row>
		</mind-form>
	</mind-layout>
</template>
<script>
import {Rest} from '@/../modules/mind-core-vue'
import dialplanExten from '@/components/dialplan-exten'
import dialplanApps from '@/components/dialplan-applications.json'


export default {
	components: {
		dialplanExten,

	},
	async created(){
		let id = this.$route.params.id
		this.api = new Rest({
			uri: `api/ami/dialplan`, 
			key: 'name'
		})

		// this.playListName = id
		if(!id || id == 'new') {
			this.isNew = true
			this.recurso = { options:[]	}
		} else {
			this.contextID = id
			this.fetch(id)
		}
	},

	computed:{
		extensionData:{
			get(){
				return this.recurso.options || []
			},
			set(v) {
				this.recurso.options = v
			}
		},
		dialplanApps() {
			return dialplanApps
		}
	},

	methods: {
		async fetch(id) {
			this.loading = true
			id = id || this.contextID
			const rec = await this.api.Fetch(id)
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
            console.log(rec)
			this.recurso = rec
			this.loading = false
		},
		async onSubmit() {
			const recurso = {
				category: this.recurso.category,
				options: this.extensionData
			}
			if(this.isNew) {
				await this.api.Post(recurso, )
					.then(()=>{
						this.fetch(this.recurso.category)
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se creó el contexto"
						})
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						})
					})
			} else {
				await this.api.Patch(recurso, `${this.contextID}`)
					.then(()=>{
						this.fetch(this.recurso.category)
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se aplicaron los cambios"
						})
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						})
					})
			}
			this.editable = ''
		},	
	},
	filters: {
		join(v) {
			if(Array.isArray(v)) {
				return v.join(', ')
			}
			return v
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {},
			api: null,
			// playListName: null,
			rawMode: false,
			loading: false,
		}
	}
}
</script>
<style lang="css" >
.el-select {
	width:100%;
}
</style>